"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNormalFragment = exports.generateConnectionFragment = void 0;
const _store_1 = require("../store");
function generateConnectionFragment(typeName, fragment) {
    const foundType = _store_1.SchemaStore.findType(typeName);
    if (foundType) {
        let outputFragment = '';
        const generateLines = (field) => {
            var _a;
            outputFragment += `${field.name} `;
            const { typeName, isScalar } = _store_1.SchemaStore.getFieldProps(field);
            if (!isScalar) {
                if (field.name === 'node') {
                    outputFragment += `{${fragment}} `;
                }
                else {
                    outputFragment += `{ `;
                    const type = _store_1.SchemaStore.findType(typeName);
                    (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach(generateLines);
                    outputFragment += `} `;
                }
            }
        };
        foundType.fields.map(generateLines);
        return outputFragment;
    }
    return null;
}
exports.generateConnectionFragment = generateConnectionFragment;
function generateNormalFragment(type, connection) {
    let outputFragment = '';
    const THRESHOLD = connection ? 4 : 2;
    const createFragmentWithDeps = (field, level) => {
        var _a, _b;
        let { typeName, isScalar, isEnum } = _store_1.SchemaStore.getFieldProps(field);
        if (!isScalar && !isEnum) {
            const type = _store_1.SchemaStore.findType(typeName);
            if (level < THRESHOLD) {
                outputFragment += `${field.name} {`;
                (_a = type === null || type === void 0 ? void 0 : type.fields) === null || _a === void 0 ? void 0 : _a.forEach((field) => createFragmentWithDeps(field, level + 1));
                outputFragment += `} `;
            }
            else if ((type === null || type === void 0 ? void 0 : type.fields) && type.fields.length < 7) {
                outputFragment += `${field.name} {`;
                (_b = type === null || type === void 0 ? void 0 : type.fields) === null || _b === void 0 ? void 0 : _b.forEach((field) => createFragmentNoDeps(field));
                outputFragment += `} `;
            }
        }
        else {
            outputFragment += `${field.name} `;
        }
    };
    const createFragmentNoDeps = (field) => {
        let { isScalar, isEnum } = _store_1.SchemaStore.getFieldProps(field);
        if (isScalar || isEnum) {
            outputFragment += `${field.name} `;
        }
    };
    type.fields.map((m) => createFragmentWithDeps(m, 0));
    return outputFragment;
}
exports.generateNormalFragment = generateNormalFragment;
